 type="CommentPreproc"/>
      </rule>
      <rule pattern="\(\*\$.*?\*\)">
        <token type="CommentPreproc"/>
      </rule>
    </state>
    <state name="comments">
      <rule pattern="^//.*?\n">
        <token type="CommentSingle"/>
      </rule>
      <rule pattern="\(\*([^$].*?)\*\)">
        <token type="CommentMultiline"/>
      </rule>
      <rule pattern="/\*(.*?)\*/">
        <token type="CommentMultiline"/>
      </rule>
    </state>
    <state name="whitespace">
      <rule pattern="\n+">
        <token type="Text"/>
      </rule>
      <rule pattern="\s+">
        <token type="Text"/>
      </rule>
    </state>
    <state name="suffixed_number_literals">
      <rule pattern="[0-7]+B">
        <token type="LiteralNumberOct"/>
      </rule>
      <rule pattern="[0-7]+C">
        <token type="LiteralNumberOct"/>
      </rule>
      <rule pattern="[0-9A-F]+H">
        <token type="LiteralNumberHex"/>
      </rule>
    </state>
    <state name="plain_number_literals">
      <rule pattern="[0-9]+(\&#39;[0-9]+)*\.[0-9]+(\&#39;[0-9]+)*[eE][+-]?[0-9]+(\&#39;[0-9]+)*">
        <token type="LiteralNumberFloat"/>
      </rule>
      <rule pattern="[0-9]+(\&#39;[0-9]+)*\.[0-9]+(\&#39;[0-9]+)*">
        <token type="LiteralNumberFloat"/>
      </rule>
      <rule pattern="[0-9]+(\&#39;[0-9]+)*">
        <token type="LiteralNumberInteger"/>
      </rule>
    </state>
    <state name="digraph_punctuation">
      <rule pattern="\.\.">
        <token type="Punctuation"/>
      </rule>
      <rule pattern="&lt;&lt;">
        <token type="Punctuation"/>
      </rule>
      <rule pattern="&gt;&gt;">
        <token type="Punctuation"/>
      </rule>
      <rule pattern="-&gt;">
        <token type="Punctuation"/>
      </rule>
      <rule pattern="\|#">
        <token type="Punctuation"/>
      </rule>
      <rule pattern="##">
        <token type="Punctuation"/>
      </rule>
      <rule pattern="\|\*">
        <token type="Punctuation"/>
      </rule>
    </state>
    <state name="unigraph_punctuation">
      <rule pattern="[()\[\]{},.:;|]">
        <token type="Punctuation"/>
      </rule>
      <rule pattern="!">
        <token type="Punctuation"/>
      </rule>
      <rule pattern="\?">
        <token type="Punctuation"/>
      </rule>
    </state>
    <state name="root">
      <rule>
        <include state="whitespace"/>
      </rule>
      <rule>
        <include state="dialecttags"/>
      </rule>
      <rule>
        <include state="pragmas"/>
      </rule>
      <rule>
        <include state="comments"/>
      </rule>
      <rule>
        <include state="identifiers"/>
      </rule>
      <rule>
        <include state="suffixed_number_literals"/>
      </rule>
      <rule>
        <include state="prefixed_number_literals"/>
      </rule>
      <rule>
        <include state="plain_number_literals"/>
      </rule>
      <rule>
        <include state="string_literals"/>
      </rule>
      <rule>
        <include state="digraph_punctuation"/>
      </rule>
      <rule>
        <include state="digraph_operators"/>
      </rule>
      <rule>
        <include state="unigraph_punctuation"/>
      </rule>
      <rule>
        <include state="unigraph_operators"/>
      </rule>
    </state>
    <state name="prefixed_number_literals">
      <rule pattern="0b[01]+(\&#39;[01]+)*">
        <token type="LiteralNumberBin"/>
      </rule>
      <rule pattern="0[ux][0-9A-F]+(\&#39;[0-9A-F]+)*">
        <token type="LiteralNumberHex"/>
      </rule>
    </state>
    <state name="digraph_operators">
      <rule pattern="\*\.">
        <token type="Operator"/>
      </rule>
      <rule pattern="\+&gt;">
        <token type="Operator"/>
      </rule>
      <rule pattern="&lt;&gt;">
        <token type="Operator"/>
      </rule>
      <rule pattern="&lt;=">
        <token type="Operator"/>
      </rule>
      <rule pattern="&gt;=">
        <token type="Operator"/>
      </rule>
      <rule pattern="==">
        <token type="Operator"/>
      </rule>
      <rule pattern="::">
        <token type="Operator"/>
      </rule>
      <rule pattern=":=">
        <token type="Operator"/>
      </rule>
      <rule pattern="\+\+">
        <token type="Operator"/>
      </rule>
      <rule pattern="--">
        <token type="Operator"/>
      </rule>
    </state>
  </rules>
</lexer>